#include "Status.h"
#include "Vram.h"
#include "VVram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 0 + VVramWidth * VramStep, "SCORE"); 
    PrintS(Vram + VramRowSize * 4 + VVramWidth * VramStep, "HI-SCORE");
    PrintS(Vram + VramRowSize * 9 + VVramWidth * VramStep, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 9 + (VVramWidth + 6) * VramStep, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 12 + VVramWidth * VramStep, "TIME");
    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 22 + (VVramWidth + 1) * VramStep;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            Print2x2(pVram, Char_Man);
            pVram += 2;
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 1 + (VVramWidth + 2) * VramStep, Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + VramRowSize * 5 + (VVramWidth + 2) * VramStep, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 12 + (VVramWidth + 5) * VramStep, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 20 + (VVramWidth + 1) * VramStep;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        *pVram = Char_Knife_Left; ++pVram;
        ++i;
        --count;
    }
    while (i != 4) {
        *pVram = Char_Space; ++pVram;
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 11 + (VVramWidth - 9) / 2 * VramStep, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 11 + (VVramWidth - 7) / 2 * VramStep, "TIME UP");
}

void Title()
{
    ClearScreen(); 
    {
        static const byte[] TitleBytes = {
            //	M
            0xe1, 0xec, 0xec, 0xfc, 
            0xe1, 0x61, 0x61, 0xa0, 
            0xe1, 0x61, 0x61, 0xa0, 
            0x7c, 0x7e, 0x7e, 0xe2, 
            //	A
            0x20, 0xfe, 0xfb, 0x7b, 
            0xe1, 0x61, 0x20, 0xa0, 
            0xe1, 0xec, 0xe2, 0xa0, 
            0x7c, 0x7e, 0x20, 0xe2, 
            //	Z
            0x7c, 0xe2, 0xfb, 0xec, 
            0x20, 0x6c, 0xec, 0x20, 
            0x6c, 0xec, 0x20, 0x20, 
            0x7c, 0xe2, 0xe2, 0xe2, 
            //	Y
            0xe1, 0x61, 0xe1, 0x61, 
            0x7c, 0xfc, 0xfe, 0x7e, 
            0x20, 0xe1, 0x61, 0x20, 
            0x20, 0x7c, 0x7e, 0x20, 
        };
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1 + 8;
        p = TitleBytes;
        repeat (4) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p; ++pVram;
                    ++p;
                }
                pVram += VramRowSize - 4 * VramStep;
            }
            pVram += 4 * VramStep - VramRowSize * 4;
        }
    }
    Print2x2(Vram + VramWidth * 8 + 8, Char_Man);
    Print2x2(Vram + VramWidth * 11 + 8, Char_Chaser);
    Print2x2(Vram + VramWidth * 14 + 8, Char_Disturber);
    Print2x2(Vram + VramWidth * 17 + 8, Char_Goal);
    
    PrintStatus(); 
    PrintS(Vram + VramWidth * 6 + 7, "--- CHARACTER ---");
    PrintS(Vram + VramWidth * 9 + 13, "MAN");
    PrintS(Vram + VramWidth * 12 + 13, "CHASER");
    PrintS(Vram + VramWidth * 15 + 13, "DISTURBER");
    PrintS(Vram + VramWidth * 18 + 13, "EXIT");

    PrintS(Vram + VramRowSize * 21 + 9, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 22 + 9, "OR  SHIFT KEY");
}
