#include "VVram.h"
#include "Chars.h"
#include "Map.h"

extern byte[] SpriteChars;

byte[VVramWidth * VVramHeight] VVram;


void VPut1(sbyte x, sbyte y, byte c)
{
    x -= BaseX;
    y -= BaseY;

    if (x < 0) return;
    if (x >= VVramWidth) return;
    if (y < 0) return;
    if (y >= VVramHeight) return;
    *VVramPtr(x, y) = c;
}

void VPut2(sbyte x, sbyte y, byte cc)
{
    constexpr byte size = 2;
    byte width, height;
    ptr<byte> pRow, pChar;

    x -= BaseX;
    y -= BaseY;

    if (x <= -size) return;
    if (x >= VVramWidth) return;
    if (y <= -size) return;
    if (y >= VVramHeight) return;

    pChar = SpriteChars + cc;
    width = size;
    if (x >= VVramWidth - size) {
        width = VVramWidth - x;
    }
    else if (x < 0) {
        width += x;
        pChar -= x;
        x = 0;
    }

    height = size;
    if (y >= VVramHeight - size) {
        height = VVramHeight - y;
    }
    else while (y < 0) {
        --height;
        ++y;
        pChar += size;
    }

    pRow = VVramPtr(x, y);

    do {
        ptr<byte> p, xp;
        byte count;
        p = pRow;
        count = width;
        xp = pChar;
        do {
            *p = *xp;
            ++p;
            ++xp;
            --count;
        } while (count != 0);
        pRow += VVramWidth;
        pChar += size;
        --height;
    } while (height != 0);
}